/*
 *            Vuze Vanish Backend GPL Version 2 License
 * 
 * The distributed software (Software) is named the "Vuze Vanish Backend" and
 * serves as a backend storage system for the Vanish system (described at
 * http://vanish.cs.washington.edu/). The Software consists of Vuze (a.k.a.
 * Azureus) Bittorrent client, version  4.2.0.2 (original and
 * latest source code of Vuze is available at http://azureus.sourceforge.net).
 * 
 * Copyright 2009, University of Washington (C) 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * All bug reports and technical questions shall be sent to:
 * vanish @ cs.washington.edu.
 * 
 */

package edu.washington.cs.vanish.internal.backend.impl;

import edu.washington.cs.vanish.util.Defaults;
import edu.washington.cs.vanish.util.FileUtil;
/**
 * 
 * @author roxana
 *
 */
class VuzeBackendDefaults {	
	public static final String VUZE_BACKEND_CONFIGURATION_FILE =
		"vuze-vanish.properties";
	
	public static final String CONF_VUZE_VANISH_RPCSERVER_PORT =
		"vuzevanish.rpcserver.port";
	public static final int CONF_VUZE_VANISH_RPCSERVER_PORT_DEFAULT =
		Defaults.CONF_VANISH_PORT_DEFAULT + 1;

	public static final String AELITIS_ADDRESS = "dht.aelitis.com:6881";
	
	public static final String CONF_VUZE_PORT = "vuze.port";
	public static final int CONF_VUZE_PORT_DEFAULT = 48386;
	
	public static final String CONF_VUZE_UDP_TIMEOUT_MIN =
		"vuze.udptimeout.min_ms";
	public static final int CONF_VUZE_UDP_TIMEOUT_MIN_DEFAULT = 200;
	
	public static final String CONF_VUZE_UDP_TIMEOUT_MAX =
		"vuze.udptimeout.max_ms";
	public static final int CONF_VUZE_UDP_TIMEOUT_MAX_DEFAULT =
		100 * CONF_VUZE_UDP_TIMEOUT_MIN_DEFAULT;
	
	public static final String CONF_VUZE_UDP_TIMEOUT_SAFE_DISTANCE_FROM_MIN =
	    "vuze.udptimeout.safedistancefrommin_ms";
	public static final int
	    CONF_VUZE_UDP_TIMEOUT_SAFE_DISTANCE_FROM_MIN_DEFAULT = 100;
	
	public static final String CONF_VUZE_UDP_TIMEOUT_RECALIBRATE_INTERVAL =
		"vuze.udptimeout.recalibrationinterval_h";
	public static final int CONF_VUZE_UDP_TIMEOUT_RECALIBRATE_INTERVAL_DEFAULT
		= 1;
	
	public static final String CONF_VUZE_BOOTSTRAP_NODE = 
		"vuze.bootstrapnode";
	public static final String CONF_VUZE_BOOTSTRAP_NODE_DEFAULT =
		AELITIS_ADDRESS;
	
	public static final String CONF_VUZE_LOOKUP_CONCURRENCY =
		"vuze.lookupconcurrency";
	public static final int CONF_VUZE_LOOKUP_CONCURRENCY_DEFAULT = 20;

	public static final String CONF_VUZE_REPLICATION_FACTOR = 
		"vuze.replicationfactor";
	public static final int CONF_VUZE_REPLICATION_FACTOR_DEFAULT = 20;
	
	public static final String CONF_VUZE_DHT_LOGGING_ON = 
		"vuze.loggingon";
	public static final boolean CONF_VUZE_DHT_LOGGING_ON_DEFAULT = false; 
	
	public static final String CONF_VUZE_STORAGE_DIR = 
		"vuze.storagedir";
	public static final String CONF_VUZE_STORAGE_DIR_DEFAULT =
		FileUtil.getPath(FileUtil.kTmpDir, "vanish", "vuze"); 
	
	// Vanish backend:
	
	public static final String CONF_VANISH_BACKEND_VUZEIMPL_DHTINDEXLEN =
		"vanish.internal.backend.vuzeimpl.dhtindexlen";
	public static final int CONF_VANISH_BACKEND_VUZEIMPL_DHTINDEXLEN_DEFAULT =
		20;
	
	public static final String CONF_VANISH_BACKEND_VUZEIMPL_RETRYSLEEP_MS =
		"vanish.internal.backend.vuzeimpl.retrysleep_ms";
	public static final int 
	CONF_VANISH_BACKEND_VUZEIMPL_RETRYSLEEP_MS_DEFAULT = 0;
	
	public static final String CONF_VANISH_BACKEND_VUZEIMPL_NUMTRIES =
		"vanish.internal.backend.vuzeimpl.numtries";
	public static final int CONF_VANISH_BACKEND_VUZEIMPL_NUMTRIES_DEFAULT = 1;
	
	public static final String
	CONF_VANISH_BACKEND_VUZEIMPL_OPERATION_BULKSIZE =
		"vanish.internal.backend.vuzeimpl.dhtoperation.bulksize";
	public static final int
	CONF_VANISH_BACKEND_VUZEIMPL_OPERATION_BULKSIZE_DEFAULT = 30;
	
	public static final String
	CONF_VANISH_BACKEND_VUZEIMPL_DELAY_OPERATION_BULKS =
		"vanish.internal.backend.vuzeimpl.dhtoperation.bulkdelay_ms";
	public static final long
	CONF_VANISH_BACKEND_VUZEIMPL_DELAY_OPERATION_BULKS_DEFAULT = 500L;
	
	
	public static final String
	CONF_VANISH_BACKEND_VUZEIMPL_INTEGRATION_TRIALS =
		"vanish.internal.backend.vuzeimpl.bootstrap_trials";
	public static final int
	CONF_VANISH_BACKEND_VUZEIMPL_INTEGRATION_TRIALS_DEFAULT = 10;
	
	public static final String
	CONF_VANISH_BACKEND_VUZEIMPL_INTEGRATION_TRIAL_INTERVAL_S =
		"vanish.internal.backend.vuzeimpl.bootstrap_trial_interval_s";
	public static final int
	CONF_VANISH_BACKEND_VUZEIMPL_INTEGRATION_TRIAL_INTERVAL_S_DEFAULT = 10;
}
